<?php

namespace app\api\controller\pay;

use Yansongda\Pay\Pay;

class WxpayController
{
    protected $config = [
        'appid' => 'wx089c26eaf96c3d51', // APP APPID
//        'app_id' => 'wxb3fxxxxxxxxxxx', // 公众号 APPID
//        'miniapp_id' => 'wxb3fxxxxxxxxxxx', // 小程序 APPID
        'mch_id' => '1680393367',
        'key' => 'c451cedbab8058e3502a35c6dacf0919',
        'notify_url' => 'http://yanda.net.cn/notify.php',
        'cert_client' => './cert/apiclient_cert.pem', // optional，退款等情况时用到
        'cert_key' => './cert/apiclient_key.pem',// optional，退款等情况时用到
        'log' => [ // optional
            'file' => './logs/wechat.log',
            'level' => 'info', // 建议生产环境等级调整为 info，开发环境为 debug
            'type' => 'single', // optional, 可选 daily.
            'max_file' => 30, // optional, 当 type 为 daily 时有效，默认 30 天
        ],
        'http' => [ // optional
            'timeout' => 5.0,
            'connect_timeout' => 5.0,
            // 更多配置项请参考 [Guzzle](https://guzzle-cn.readthedocs.io/zh_CN/latest/request-options.html)
        ],
//        'mode' => 'dev', // optional, dev/hk;当为 `hk` 时，为中国香港 gateway。
    ];

    public function index()
    {
        $order = [
            'out_trade_no' => time(),
            'body' => 'subject-测试',
            'total_fee' => '1',
        ];

        $pay = Pay::wechat($this->getConfig())->app($order)->send();

        // $pay->appId
        // $pay->timeStamp
        // $pay->nonceStr
        // $pay->package
        // $pay->signType
    }

    public function notify()
    {
        $pay = Pay::wechat($this->config);

        try {
            $data = $pay->verify(); // 是的，验签就这么简单！

            Log::debug('Wechat notify', $data->all());
        } catch (\Exception $e) {
            // $e->getMessage();
        }

        return $pay->success()->send();// laravel 框架中请直接 `return $pay->success()`
    }

    private function getConfig()
    {
        return [
            'appid' => 'wx089c26eaf96c3d51', // APP APPID
            'mch_id' => '1680393367',
            'key' => 'c451cedbab8058e3502a35c6dacf0919',
            'notify_url' => 'http://yanda.net.cn/notify.php',
            'cert_client' => config_path('cert/wxpay/apiclient_cert.pem'), // optional，退款等情况时用到
            'cert_key' => config_path('cert/wxpay/apiclient_key.pem'),// optional，退款等情况时用到
            'log' => [ // optional
                'file' => runtime_path('logs/wechat.log'),
                'level' => 'info', // 建议生产环境等级调整为 info，开发环境为 debug
                'type' => 'single', // optional, 可选 daily.
                'max_file' => 30, // optional, 当 type 为 daily 时有效，默认 30 天
            ],
            'http' => [ // optional
                'timeout' => 5.0,
                'connect_timeout' => 5.0,
                // 更多配置项请参考 [Guzzle](https://guzzle-cn.readthedocs.io/zh_CN/latest/request-options.html)
            ],
            'mode' => 'dev', // optional, dev/hk;当为 `hk` 时，为中国香港 gateway。
        ];
    }
}